Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.jdbc.meta
Class Version

    java.lang.Object
      org.apache.openjpa.jdbc.meta.Version

All Implemented Interfaces:
  Serializable, Strategy, VersionStrategy, MetaDataContext, MetaDataModes

    public class Version

extends Object
implements VersionStrategy, MetaDataContext, MetaDataModes

Handles optimistic lock versioning for a class.

Author:
  Abe White
See Also:
  Serialized Form

Field Summary

Fields inherited from interface org.apache.openjpa.meta.MetaDataModes
`MODE_ALL, MODE_ANN_MAPPING, MODE_MAPPING, MODE_MAPPING_INIT, MODE_META, MODE_NONE, MODE_QUERY`

Constructor Summary
`Version(ClassMapping mapping)` Constructor.

Method Summary
`void` | `afterLoad(OpenJPAStateManager sm, JDBCStore store)` This method is called after data is loaded into the instance, in case the version indicator works off of a state image.
`boolean` | `checkVersion(OpenJPAStateManager sm, JDBCStore store, boolean updateVersion)` Checks the version of the given state manager with the version stored in memory.
`void` | `clearMapping()` Clear mapping information, including strategy.
`int` | `compareVersion(Object v1, Object v2)`
`void` | `customDelete(OpenJPAStateManager sm, JDBCStore store)` Override this method to customize flushing this mapping.
`void` | `customInsert(OpenJPAStateManager sm, JDBCStore store)` Override this method to customize flushing this mapping.
`void` | `customUpdate(OpenJPAStateManager sm, JDBCStore store)` Override this method to customize flushing this mapping.
`void` | `delete(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set the where values appropriately to delete the proper instance, and set all relations on non-secondary tables as updates.
`String` | `getAlias()` Return the alias of this strategy.
`Map<Column,?>` | `getBulkUpdateValues()`
`ClassMapping` | `getClassMapping()` Return the owning mapping.
`ColumnIO` | `getColumnIO()` I/O information on the version columns.
`Column[]` | `getColumns()` Columns used for versioning.
`Index` | `getIndex()` Index on the version columns, or null if none.
`VersionMappingInfo` | `getMappingInfo()` Raw mapping data.
`MappingRepository` | `getMappingRepository()`
`MetaDataRepository` | `getRepository()` Access metadata repository.
`int` | `getResolve()` Resolve mode.
`VersionStrategy` | `getStrategy()` The strategy used for versioning.
`void` | `initialize()` Perform caching and other initialization operations.
`void` | `insert(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set values for the mapping into the proper rows.
`Boolean` | `isCustomDelete(OpenJPAStateManager sm, JDBCStore store)` Return `Boolean.FALSE` if this mapping does not customize the delete process, `Boolean.TRUE` if it does, or null if it does customize the delete, but also relies on the standard delete method being called.
`Boolean` | `isCustomInsert(OpenJPAStateManager sm, JDBCStore store)` Return `Boolean.FALSE` if this mapping does not customize the insert process, `Boolean.TRUE` if it does, or null if it does customize the insert, but also relies on the standard insert method being called.
`Boolean` | `isCustomUpdate(OpenJPAStateManager sm, JDBCStore store)` Return `Boolean.FALSE` if this mapping does not customize the update process, `Boolean.TRUE` if it does, or null if it does customize the update, but also relies on the standard update method being called.
`Object` | `load(OpenJPAStateManager sm, JDBCStore store, Result res)` Load data.
`void` | `map(boolean adapt)` Map the owning mapping using this strategy.
`void` | `refSchemaComponents()` Increment the reference count of used schema components.
`boolean` | `resolve(int mode)` Resolve mapping information.
`boolean` | `select(Select sel, ClassMapping mapping)` Select the data for this indicator.
`void` | `setColumnIO(ColumnIO io)` I/O information on the version columns.
`void` | `setColumns(Column[] cols)` Columns used for versioning.
`void` | `setIndex(Index idx)` Index on the version columns, or null if none.
`void` | `setResolve(int mode)` Resolve mode.
`void` | `setResolve(int mode, boolean on)` Resolve mode.
`void` | `setStrategy(VersionStrategy strategy, Boolean adapt)` The strategy used for versioning.
`void` | `setVersion(Version owner)` Set the version that uses this strategy.
`void` | `syncMappingInfo()` Update `MappingInfo` with our current mapping information.
`String` | `toString()`
`void` | `update(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set values for the mapping into the proper rows.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Version

    public Version(ClassMapping mapping)

  Constructor. Supply owning mapping.

Method Detail

### getRepository

    public MetaDataRepository getRepository()

  Description copied from interface: `MetaDataContext`
  Access metadata repository.

  Specified by:
    `getRepository` in interface `MetaDataContext`

### getMappingRepository

    public MappingRepository getMappingRepository()

### getClassMapping

    public ClassMapping getClassMapping()

  Return the owning mapping.

### getStrategy

    public VersionStrategy getStrategy()

  The strategy used for versioning.

### setStrategy

    public void setStrategy(VersionStrategy strategy,
                            Boolean adapt)

  The strategy used for versioning. The `adapt` parameter determines whether to adapt when mapping the strategy; use null if the strategy should not be mapped.

### getMappingInfo

    public VersionMappingInfo getMappingInfo()

  Raw mapping data.

### getColumns

    public Column[] getColumns()

  Columns used for versioning.

### setColumns

    public void setColumns(Column[] cols)

  Columns used for versioning.

### getColumnIO

    public ColumnIO getColumnIO()

  I/O information on the version columns.

### setColumnIO

    public void setColumnIO(ColumnIO io)

  I/O information on the version columns.

### getIndex

    public Index getIndex()

  Index on the version columns, or null if none.

### setIndex

    public void setIndex(Index idx)

  Index on the version columns, or null if none.

### refSchemaComponents

    public void refSchemaComponents()

  Increment the reference count of used schema components.

### clearMapping

    public void clearMapping()

  Clear mapping information, including strategy.

### syncMappingInfo

    public void syncMappingInfo()

  Update `MappingInfo` with our current mapping information.

### getResolve

    public int getResolve()

  Resolve mode.

### setResolve

    public void setResolve(int mode)

  Resolve mode.

### setResolve

    public void setResolve(int mode,
                           boolean on)

  Resolve mode.

### resolve

    public boolean resolve(int mode)

  Resolve mapping information.

### getAlias

    public String getAlias()

  Description copied from interface: `Strategy`
  Return the alias of this strategy. For custom strategies, return the full class name.

  Specified by:
    `getAlias` in interface `Strategy`

### map

    public void map(boolean adapt)

  Description copied from interface: `Strategy`
  Map the owning mapping using this strategy.

  Specified by:
    `map` in interface `Strategy`
  Parameters:
    `adapt` - if true, use the owning mapping's raw mapping info to set its ORM data; if false, ORM data will already be set

### initialize

    public void initialize()

  Description copied from interface: `Strategy`
  Perform caching and other initialization operations. This method is called after `Strategy.map(boolean)`, and after all related components have been mapped as well.

  Specified by:
    `initialize` in interface `Strategy`

### insert

    public void insert(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set values for the mapping into the proper rows. For class mappings, this method will be called only after the corresponding method has been called for all fields of this mapping.

  Specified by:
    `insert` in interface `Strategy`
  Throws:
    `SQLException`

### update

    public void update(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set values for the mapping into the proper rows.

  Specified by:
    `update` in interface `Strategy`
  Throws:
    `SQLException`
  See Also:
    `Strategy.insert(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.sql.RowManager)`

### delete

    public void delete(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set the where values appropriately to delete the proper instance, and set all relations on non-secondary tables as updates. This allows foreign key analysis.

  Specified by:
    `delete` in interface `Strategy`
  Throws:
    `SQLException`
  See Also:
    `Strategy.insert(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.sql.RowManager)`

### isCustomInsert

    public Boolean isCustomInsert(OpenJPAStateManager sm,
                                  JDBCStore store)

  Description copied from interface: `Strategy`
  Return `Boolean.FALSE` if this mapping does not customize the insert process, `Boolean.TRUE` if it does, or null if it does customize the insert, but also relies on the standard insert method being called. Implement the `Strategy.customInsert(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore)` method to implement the custom insertion behavior.

  Specified by:
    `isCustomInsert` in interface `Strategy`

### isCustomUpdate

    public Boolean isCustomUpdate(OpenJPAStateManager sm,
                                  JDBCStore store)

  Description copied from interface: `Strategy`
  Return `Boolean.FALSE` if this mapping does not customize the update process, `Boolean.TRUE` if it does, or null if it does customize the update, but also relies on the standard update method being called. Implement the `Strategy.customUpdate(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore)` method to override the default update behavior.

  Specified by:
    `isCustomUpdate` in interface `Strategy`

### isCustomDelete

    public Boolean isCustomDelete(OpenJPAStateManager sm,
                                  JDBCStore store)

  Description copied from interface: `Strategy`
  Return `Boolean.FALSE` if this mapping does not customize the delete process, `Boolean.TRUE` if it does, or null if it does customize the delete, but also relies on the standard delete method being called. Implement the `Strategy.customDelete(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore)` method to override the default deletion behavior.

  Specified by:
    `isCustomDelete` in interface `Strategy`

### customInsert

    public void customInsert(OpenJPAStateManager sm,
                             JDBCStore store)
                      throws SQLException

  Description copied from interface: `Strategy`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields. For fields, this method is called after the owning object is inserted, so if this field is in a row with other fields, that row will already exist.

  Specified by:
    `customInsert` in interface `Strategy`
  Throws:
    `SQLException`

### customUpdate

    public void customUpdate(OpenJPAStateManager sm,
                             JDBCStore store)
                      throws SQLException

  Description copied from interface: `Strategy`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields.

  Specified by:
    `customUpdate` in interface `Strategy`
  Throws:
    `SQLException`

### customDelete

    public void customDelete(OpenJPAStateManager sm,
                             JDBCStore store)
                      throws SQLException

  Description copied from interface: `Strategy`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields. For fields, this method will be called after the owning object is deleted.

  Specified by:
    `customDelete` in interface `Strategy`
  Throws:
    `SQLException`

### setVersion

    public void setVersion(Version owner)

  Description copied from interface: `VersionStrategy`
  Set the version that uses this strategy. This will be called before use.

  Specified by:
    `setVersion` in interface `VersionStrategy`

### select

    public boolean select(Select sel,
                          ClassMapping mapping)

  Description copied from interface: `VersionStrategy`
  Select the data for this indicator.

  Specified by:
    `select` in interface `VersionStrategy`
    `mapping` - the known base class being selected; this may not be the base class in the inheritance hierarchy
  Returns:
    true if anything was selected; false otherwise

### load

    public Object load(OpenJPAStateManager sm,
                       JDBCStore store,
                       Result res)
                throws SQLException

  Description copied from interface: `VersionStrategy`
  Load data.

  Specified by:
    `load` in interface `VersionStrategy`
  Throws:
    `SQLException`

### afterLoad

    public void afterLoad(OpenJPAStateManager sm,
                          JDBCStore store)

  Description copied from interface: `VersionStrategy`
  This method is called after data is loaded into the instance, in case the version indicator works off of a state image.

  Specified by:
    `afterLoad` in interface `VersionStrategy`

### checkVersion

    public boolean checkVersion(OpenJPAStateManager sm,
                                JDBCStore store,
                                boolean updateVersion)
                         throws SQLException

  Description copied from interface: `VersionStrategy`
  Checks the version of the given state manager with the version stored in memory.

  Specified by:
    `checkVersion` in interface `VersionStrategy`
  Returns:
    true if the in-memory version was up-to-date, false otherwise
  Throws:
    `SQLException`

### compareVersion

    public int compareVersion(Object v1,
                              Object v2)

  Specified by:
    `compareVersion` in interface `VersionStrategy`
  See Also:
    `StoreManager.compareVersion(org.apache.openjpa.kernel.OpenJPAStateManager, java.lang.Object, java.lang.Object)`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getBulkUpdateValues

    public Map<Column,?> getBulkUpdateValues()

  Specified by:
    `getBulkUpdateValues` in interface `VersionStrategy`
  Returns:
    a Map specifying how to update each version column in this instance during a bulk update.
  Since:
    1.0.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.